<?php
/*
 checksysreport, a tool to spot unsupported issues.
# Copyright 2005 Pierre Amadio 
# pamadio@redhat.com
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation version 2.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//http://uk2.php.net/features.file-upload
include("./template.inc.php");

$uploaddir = '/var/www/checksysreport-spool';
$tmpldir="/var/www/html/wcs";

$db=pg_connect("dbname=checksysreportdb")
  or die('Could not connect: ' . pg_last_error());

//http://www.kitebird.com/articles/peardb.html

$architectures=array(
		     "autodetect"=>"auto detect",
		     "i386"=>"i386",
		     "x86_64"=>"x86_64",
		     "ppc"=>"ppc",
		     "s390"=>"s390",
		     "s390x"=>"s390x",
		     "ia64"=>"ia64"
);

function display_array($target) {
  print "<table border=1>";
  //reset($target);
  @reset($target);
  while(list($clef,$val)=@each($target)) {
    print "<tr><td>$clef</td><td>";
    if(is_array($val)){display_array($val);} else {print $val;}
    print "</td></tr>";
  }
  print "</table>";
}



function check_problems(){
  global $_POST,$_FILES;
  $email=$_POST['email'];
  $crm=$_POST['crm'];
  $sysreport=$_FILES['sysreport'];

  $out=array();

  if( !preg_match( "/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/", $email)) {
    $out[]="The email does not look valid";
  }
  if( preg_match( "/\D/", $crm)) {
    $out[]="crm must only countain number";
  }
  if (!strlen($crm)){
    $out[]="You need a crm number";
  }
  if(!$sysreport['size']){
    $out[]="There is no sysreport attached";
  }

  if(strlen($sysreport['name'])>30){
    $out[]="The sysreport file name is too long";
  }

  if( preg_match("/\(/",$sysreport['name'])){
    $out[]="The sysreport name must not contain any open parenthesis.";
  }

  if($sysreport['error'] and $sysreport['size']){
    $out[]="Problem uploading the sysreport:".$sysreport['error'].".<br>See <a href=\"http://uk2.php.net/manual/en/features.file-upload.errors.php\">here</a> for more information";
  }


  return $out;
}

function show_form($params){
  global $architectures,$tmpldir;
  $tmpl=new Template ($tmpldir);
  $tmpl->set_file("common","index.ihtml");
  $tmpl->set_block("common","pb","pbblok");
  $tmpl->set_block("common","arch","archblok");

  while(list($k,$v)=@each($params['problems'])){
    $tmpl->set_var("PB",$v);
    $tmpl->parse("pbblok","pb",true);
  }

  while(list($k,$v)=@each($architectures)){
    if($params['arch']==$k){
      $selsnt="SELECTED";
    } else {$selsnt="";}
    $tmpl->set_var(array(
			 "VAL_ARCH"=>$k,
			 "SEL_ARCH"=>$selsnt,
			 "LABEL_ARCH"=>$v
			 ));
    $tmpl->parse("archblok","arch",true);
  }
  

  $tmpl->set_var(array(
		       "SELF"=>$_SERVER["PHP_SELF"],
		       "EMAIL"=>$params['email'],
		       "CRM"=>$params['crm']
	       ));
  $tmpl->parse("out","common");
  $tmpl->p("out");
  exit;
}

if(!isset($_POST['fflag'])) {
  $params=array("problems"=>array(),
		"email"=>"",
		"crm"=>"",
		"arch"=>"autodetect"
		);
  show_form($params);
    }

$problems=check_problems();
if(sizeof($problems)){
  $params=array(
		"problems"=>$problems,
		"email"=>$_POST["email"],
		"crm"=>$_POST["crm"],
		"arch"=>$_POST["arch"]
		);
  show_form($params);
}

$email=$_POST['email'];
$crm=$_POST['crm'];
$arch=$_POST['arch'];
$orig_file_name=basename($_FILES['sysreport']['name']);



//I wonder if this should be included in a transaction...not sure about pg_last_oid($ressource);
$stmt = "insert into Spool (email,arch,crm,orig_file_name,request_date) values ('$email','$arch','$crm','$orig_file_name',now())";
$ressource=pg_query($stmt) or die('Query failed: ' . pg_last_error().'<br>$stmt');
$oid=pg_last_oid($ressource);
$res2=pg_query("select id from Spool where oid=$oid") or die('Query failed: ' . pg_last_error());
$resarray=pg_fetch_array($res2);
$lastInsertId=$resarray['id'];
$uploadfilename = $uploaddir."/$lastInsertId-".$orig_file_name;

if (move_uploaded_file($_FILES['sysreport']['tmp_name'],$uploadfilename)) {
  chmod($uploadfilename,0660);
  chgrp($uploadfilename,'checksysreport');
  $tmpl=new Template ($tmpldir);
  $tmpl->set_file("common","ok.ihtml");
  $tmpl->set_var("EMAIL",$email);
  $tmpl->parse("out","common");
  $tmpl->p("out");
} else {
  echo '<pre>';
  echo "Possible file upload attack!\n";
  echo 'Here is some more debugging info:';
  print_r($_FILES);
  print "</pre>";
  pg_query('delete from Spool where id='+$lastInsertId) or die('Query failed: ' . pg_last_error());

}

?>
